From: =?UTF-8?q?Jean-Pierre=20Andr=C3=A9?= <jean-pierre.andre@wanadoo.fr>
Date: Tue, 10 May 2022 10:48:18 +0200
Subject: Hardened the checking of directory offset requested by a readdir
Origin: https://github.com/tuxera/ntfs-3g/commit/fb28eef6f1c26170566187c1ab7dc913a13ea43c
Bug-Debian: https://bugs.debian.org/1011770
Bug-Debian-Security: https://security-tracker.debian.org/tracker/CVE-2022-30787
Bug-Debian-Security: https://security-tracker.debian.org/tracker/CVE-2022-30785

When asked for the next directory entries, make sure the chunk offset
is within valid values, otherwise return no more entries in chunk.
---
 libfuse-lite/fuse.c | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

diff --git a/libfuse-lite/fuse.c b/libfuse-lite/fuse.c
index 6f9242b776b6..3d653e634b93 100644
--- a/libfuse-lite/fuse.c
+++ b/libfuse-lite/fuse.c
@@ -2223,7 +2223,7 @@ static void fuse_lib_readdir(fuse_req_t req, fuse_ino_t ino, size_t size,
         }
     }
     if (dh->filled) {
-        if (off < dh->len) {
+        if ((off >= 0) && (off < dh->len)) {
             if (off + size > dh->len)
                 size = dh->len - off;
         } else
-- 
2.36.1

